---
name: RFC Submission
about: Propose a new idea or significant change for consideration
title: Concise description of the proposal
labels: C-rfc
---

<!-- Thank you for taking the time to propose a new idea or significant change. Please provide a comprehensive overview of the concepts and motivations at play. -->

### Summary

<!-- Briefly summarize the idea, change, or feature you are proposing. What is it about, and what does it aim to achieve? -->

### Context and Problem Statement

<!-- Describe the problem or inadequacy of the current situation/state that your proposal is addressing. This is a key aspect of putting your RFC into context. -->

### Proposal

<!-- Clearly and comprehensively describe your proposal including high-level technical specifics, any new interfaces or APIs, and how it should integrate into the existing system. -->

### Motivation and Rationale

<!-- Elaborate on why this proposal is important. Provide justifications for why it should be considered and what benefits it brings. Include use cases, user stories, and pain points it intends to solve. -->

### Detailed Design

<!-- Dive into the nitty-gritty details of your proposal. Discuss possible implementation strategies, potential issues, and how the proposal would alter workflows, behaviors, or structures. Include pseudocode, diagrams, or mock-ups if possible. -->

### Alternatives Considered

<!-- Detail any alternative solutions or features you've considered. Why were they discarded in favor of this proposal? -->

### Additional Information and Resources

<!-- Offer any additional information, context, links, or resources that stakeholders might find helpful for understanding the proposal. -->

### Open Questions

<!-- List any questions that you have that might need further discussion. This can include areas where you are seeking feedback or require input to finalize decisions. -->

### Future Possibilities

<!-- If your RFC is likely to lead to subsequent changes, provide a brief outline of what those might be and how your proposal may lay the groundwork for them. -->

<!-- We appreciate your effort in contributing to the evolution of our system and look forward to reviewing and discussing your ideas! -->
